%module vtk
%include typemaps.i
%include vtk_typemaps.i
%include vtkCommon_typemaps.i


%{
#include "vtkImageData.h"
#include "vtkDataArray.h"
#include "vtkLine.h"
#include "vtkPixel.h"
#include "vtkVertex.h"
#include "vtkVoxel.h"
%}

%import vtkDataSet.h
%import vtkStructuredData.h


%{
extern void vtkImageData_freefunc(void *ptr)
{
    vtkImageData *obj;
    obj = (vtkImageData*)ptr;
    obj->Delete();
}
%}

%typemap(ruby,out) int value[6] {
  int i;
  $result = rb_ary_new2(6);
  for (i=0; i<6; i++)
    rb_ary_store($result,i,INT2NUM($1[i]));
}
%apply int value[6]{
   int *GetExtent()
}
%ignore GetExtent(int data[6]);
%ignore GetExtent(int _arg[6]);
%ignore GetExtent(int &_arg1,int &_arg2,int &_arg3,int &_arg4,int &_arg5,int &_arg6);

%typemap(ruby,out) float value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new((double)$1[i]));
}
%apply float value[3]{
   float *GetSpacing()
}
%ignore GetSpacing(float data[3]);
%ignore GetSpacing(float _arg[3]);
%ignore GetSpacing(float &_arg1,float &_arg2,float &_arg3);

%typemap(ruby,out) float value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new((double)$1[i]));
}
%apply float value[3]{
   float *GetOrigin()
}
%ignore GetOrigin(float data[3]);
%ignore GetOrigin(float _arg[3]);
%ignore GetOrigin(float &_arg1,float &_arg2,float &_arg3);

%include vtkImageData.h
