%module vtk
%include typemaps.i
%include vtk_typemaps.i
%include vtkCommon_typemaps.i


%{
#include "vtkLookupTable.h"
%}

%import vtkScalarsToColors.h
%import vtkUnsignedCharArray.h


%{
extern void vtkLookupTable_freefunc(void *ptr)
{
    vtkLookupTable *obj;
    obj = (vtkLookupTable*)ptr;
    obj->Delete();
}
%}

%typemap(ruby,out) float value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new((double)$1[i]));
}
%apply float value[2]{
   float *GetTableRange()
}
%ignore GetTableRange(float data[2]);
%ignore GetTableRange(float _arg[2]);
%ignore GetTableRange(float &_arg1,float &_arg2);

%typemap(ruby,out) float value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new((double)$1[i]));
}
%apply float value[2]{
   float *GetHueRange()
}
%ignore GetHueRange(float data[2]);
%ignore GetHueRange(float _arg[2]);
%ignore GetHueRange(float &_arg1,float &_arg2);

%typemap(ruby,out) float value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new((double)$1[i]));
}
%apply float value[2]{
   float *GetSaturationRange()
}
%ignore GetSaturationRange(float data[2]);
%ignore GetSaturationRange(float _arg[2]);
%ignore GetSaturationRange(float &_arg1,float &_arg2);

%typemap(ruby,out) float value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new((double)$1[i]));
}
%apply float value[2]{
   float *GetValueRange()
}
%ignore GetValueRange(float data[2]);
%ignore GetValueRange(float _arg[2]);
%ignore GetValueRange(float &_arg1,float &_arg2);

%typemap(ruby,out) float value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new((double)$1[i]));
}
%apply float value[2]{
   float *GetAlphaRange()
}
%ignore GetAlphaRange(float data[2]);
%ignore GetAlphaRange(float _arg[2]);
%ignore GetAlphaRange(float &_arg1,float &_arg2);

%include vtkLookupTable.h
