%module vtk
%include typemaps.i
%include vtk_typemaps.i
%include vtkRendering_typemaps.i


%{
#include "vtkLightKit.h"
#include "vtkLight.h"
#include "vtkRenderer.h"
%}

%import vtkObject.h


%{
extern void vtkLightKit_freefunc(void *ptr)
{
    vtkLightKit *obj;
    obj = (vtkLightKit*)ptr;
    obj->Delete();
}
%}

%typemap(ruby,out) float value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new((double)$1[i]));
}
%apply float value[3]{
   float *GetKeyLightColor()
}
%ignore GetKeyLightColor(float data[3]);
%ignore GetKeyLightColor(float _arg[3]);
%ignore GetKeyLightColor(float &_arg1,float &_arg2,float &_arg3);

%typemap(ruby,out) float value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new((double)$1[i]));
}
%apply float value[3]{
   float *GetFillLightColor()
}
%ignore GetFillLightColor(float data[3]);
%ignore GetFillLightColor(float _arg[3]);
%ignore GetFillLightColor(float &_arg1,float &_arg2,float &_arg3);

%typemap(ruby,out) float value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new((double)$1[i]));
}
%apply float value[3]{
   float *GetHeadlightColor()
}
%ignore GetHeadlightColor(float data[3]);
%ignore GetHeadlightColor(float _arg[3]);
%ignore GetHeadlightColor(float &_arg1,float &_arg2,float &_arg3);

%typemap(ruby,out) float value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new((double)$1[i]));
}
%apply float value[3]{
   float *GetBackLightColor()
}
%ignore GetBackLightColor(float data[3]);
%ignore GetBackLightColor(float _arg[3]);
%ignore GetBackLightColor(float &_arg1,float &_arg2,float &_arg3);

%typemap(ruby,out) float value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new((double)$1[i]));
}
%apply float value[2]{
   float *GetKeyLightAngle()
}
%ignore GetKeyLightAngle(float data[2]);
%ignore GetKeyLightAngle(float _arg[2]);
%ignore GetKeyLightAngle(float &_arg1,float &_arg2);

%typemap(ruby,out) float value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new((double)$1[i]));
}
%apply float value[2]{
   float *GetFillLightAngle()
}
%ignore GetFillLightAngle(float data[2]);
%ignore GetFillLightAngle(float _arg[2]);
%ignore GetFillLightAngle(float &_arg1,float &_arg2);

%typemap(ruby,out) float value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new((double)$1[i]));
}
%apply float value[2]{
   float *GetBackLightAngle()
}
%ignore GetBackLightAngle(float data[2]);
%ignore GetBackLightAngle(float _arg[2]);
%ignore GetBackLightAngle(float &_arg1,float &_arg2);

%include vtkLightKit.h
